!     the file hpg_mossbauer.f containes the following subroutines:        
!     subroutine moss_plot(cmch)                                       
!     subroutine drive(mode_drive)                                     
!                is also used by fr_strobmoss.f                        
!     subroutine geometry(ichansp,cosa,a_R,jt)                         
!     subroutine moss_selsubspect(text)                                
!     subroutine moss_selsubtract(text,isub)                           
!     subroutine moss_subspect(cmch,mi,isub,info)                      
!     subroutine moss_subtract(cmch,mi,isub,info)                      
!     subroutine mosstrans_mcarlo(nu_channel)                          

     subroutine moss_plot(cmch) 
     use glbconst, only: maxn,max8,maxsub,maxscrt,infplot,MDBPLFT,    &
                         icstrf,ivstrf
     use comdat, only: file_data,name_data,formdata,b_data,b_theory,   &
                       name_theory,mfpt,mdfpt,ichanks
     use complt, only: display_mode,ndisplay_mode,n_subset,icolor_sub
     use comthe, only: real_fr,thfk
     implicit none                                                                  
     character(len=4),intent(in)::  cmch 
                                                                       
     integer      n_subspectra,logx,logy,logf,         &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         xyzdz,vtxt,vtxtp,parray                              

     character(len=132):: plotstrpu,title
     character(len=24) :: axesname,abscissa,ordinata,bgcolor,fgcolor,   &  
                          datacolor,thcolor,rescolor,auxcolor1,         &        
                          auxcolor2,auxcolor3
     character(len=80) :: datfile,plotstrdef 
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,chardum
                  
     integer,parameter :: max8subn=maxsub*max8,                                &
                 idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-188  
     common/plot/parray(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32), &
                 int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,chardum(idumpl) 
                                                                       
     real,dimension(max8):: plotx,ploty,ploterry,plotres,plotxx,plotyy
     real,dimension(max8subn):: plotsub
     equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),       &
                 (parray(max8*2+1),ploterry(1)),                       &
                 (parray(max8*3+1),plotres(1)),                        &
                 (parray(max8*4+1),plotxx(1)),                         &
                 (parray(max8*5+1),plotyy(1)),                         &
                 (parray(max8*6+1),plotsub(1)) 
                        
     real          dum1,channels,dum2,channels_vmax,dumcsp
     common/acstrf/dum1(5),                                            &
                   channels,dum2(4),channels_vmax,dumcsp(icstrf-11)
     real      avsp,f_factor,base,bg_fraction,v_max,channel_v0,dumvsp
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,channel_v0,    &
                   dumvsp(ivstrf-6)                                    
     logical             b_datf
     integer,parameter:: maxn0=maxn+2,maxnh=maxn/2,                    &
                         mscrplot=8*maxn0+4*maxnh,                     &
                         idumscrt=maxscrt-4*maxn-maxn*maxsub-mscrplot          
     real        datx,errx,sym,subspectrum,varray,yarray,yyarray,      &
                 v1array,v3array,vrarray,vdarray,resarray
     integer     irarray,i0array,i1array,i2array,idumsc
     common/scrt/datx(maxn),errx(maxn),sym(maxn),                      &
                 subspectrum(maxn,maxsub),                             &
                 varray(maxn0),yarray(maxn0),yyarray(maxn0),           &
                 v1array(maxn0),v3array(maxn0),vrarray(maxn0),         &
                 vdarray(maxn0),irarray(maxnh),i0array(maxnh),         &
                 i1array(maxnh),i2array(maxnh),resarray(maxn0),        &
                 b_datf(maxn),idumsc(idumscrt)                         
 
     real            velocity,geof,dfdgeo 
     common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn) 
                                                                       
     logical         b_logx,b_logy,b_vdarray
     character(len=1) :: chx,chbx,chlr,chy,chby,chbt,ch0 
     character(len=80):: CTEXT,CXTEXT,CYTEXT
     character(len=24):: frcolor
     character(len=9) :: chsub
     integer         nformx,nformy,i,ii,iiii,il,ir,irh,is1,is2,i0,il0,&
                     il1,il2,ivd,l,k,nbegin,nchansp,nend,nh,nresidue, &
                     j,ns,nsinglev,ny,nyy
     real            chh,chw,syw,syh,aa,base2,basepl,bb,ff,det,glow,  &
                     fold_point,sqrt2,v1,v1mv3,v3,vil,vil1,vil2,vir,  &
                     vr,xmax,xmin,y1,y2,y3,ymin,ymax,hd,resmin,resmax 
                                                                        
      ch0=char(0) 
      i0=ichar('0') 
      if(cmch.eq.'dstr') then 
       formdata(1)='y,dy' 
       formdata(2)='y,dy' 
       formdata(3)='y,dy,x' 
       return 
      end if 
      if(cmch.eq.'dmod') then 
       display_mode(1)='channel scale, counts' 
       display_mode(2)='channel scale, counts, residual spectrum' 
       display_mode(3)='velocity scale' 
       display_mode(4)='velocity scale, residual spectrum' 
       display_mode(5)='velocity scale, counts' 
       display_mode(6)='velocity scale, counts, residual spectrum' 
       display_mode(7)=' ' 
       display_mode(8)=' ' 
       namechan(1)='x' 
       namechan(2)='y' 
       namechan(3)='dy' 
       namechan(4)='res' 
       namechan(5)='xt' 
       namechan(6)='yt' 
       namechan(7)='su' 
       namechan(8)=' ' 
       plotstrdef='(x,y,dy)' 
       if(b_theory)then 
        plotstrdef='(x,y,dy) (xt,yt)' 
        j=21 
        if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4                     &
     &                         .or.ndisplay_mode.eq.6)then              
         plotstrdef='(x,y,dy) (xt,yt) (x,res)' 
         j=30 
        end if 
        if(n_subset.gt.0)then 
         do i=1,n_subset 
          chsub=' (xt,su'//char(i+i0)//')' 
          k=j+(i-1)*9 
          plotstrdef(k:)=chsub 
         end do 
        end if 
       end if 
       return 
      end if 
                                                                        
      if(ndisplay_mode.eq.3.or.ndisplay_mode.eq.4) then 
       kform(1)='f6.2' 
       kform(2)='f10.6' 
       kform(3)='f10.6' 
       kform(4)='f10.6' 
       kform(5)='f6.2' 
       kform(6)='f10.6' 
       kform(7)='f10.6' 
       nformy=2 
      else if(ndisplay_mode.le.2.or.ndisplay_mode.ge.5) then 
       kform(1)='f8.2,2x' 
       kform(2)='f10.2,2x' 
       kform(3)='f8.1,2x' 
       kform(4)='f10.1,2x' 
       kform(5)='f6.0,2x' 
       kform(6)='f10.0,2x' 
       kform(7)='f10.0,2x' 
       nformy=0 
      end if 
      kform(8)=' ' 
                                                                        
      goto(3,4,1,2,5,5), ndisplay_mode 
!       display_mode(1)='velocity scale'                                
    1  abscissa='mm/s' 
       ordinata='relative transmission' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=1 
       goto 6 
!       display_mode(2)='-velocity scale, residual spectrum'            
    2  abscissa='mm/s' 
       ordinata='relative transmission' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=1 
       goto 6 
!       display_mode(3)='channel scale'                                 
    3  abscissa='channel' 
       ordinata='counts' 
       axisformat(1)='%8.2f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
       goto 6 
!       display_mode(4)='-channel scale, residual spectrum'             
    4  abscissa='channel' 
       ordinata='counts' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%8.0f ' 
       nformx=0 
       goto 6 
!      display_mode(5,6)='-velocity scale, counts, residual spectrum'   
    5  abscissa='mm/s' 
       ordinata='counts' 
       axisformat(1)='%8.2f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
    6  continue 
                                                                        
       n_subspectra=0 
       if(b_theory) n_subspectra=n_subset 
!      n_subset may be not defined                                      
                                                                        
       nchansp=channels 
       fold_point=channel_v0+channels_vmax 
!      write(6,'(a,i4)') ' *****moss_plot*********'                     
!      write(6,'(3(a,i6))') ' idumscr=',idumscr,'  maxscrt=',maxscrt    
!       write(6,'(2(a,l5),a,i5)') ' b_data=',b_data,                    
!     &  '  b_theory=',b_theory,' n_subspectra=',n_subspectra           
!       write(6,'(4(a,f10.3))') ' base=',base,'  geo=',geo,             
!     &         '  fold=',fold_point,'  fresonant=',fresonant           
                                                                        
                                                                        
!     if(b_theory) then                                                 
!      write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)                     
!     else                                                              
!      write(6,'(20L4)') (b_datf(j),j=1,nchansp,16)                     
!     end if                                                            
                                                                        
      do j=1,nchansp 
       b_datf(j)=.false. 
      end do 
      do k=2,ichanks(0),2 
       do j=ichanks(k-1),ichanks(k) 
        b_datf(j)=.true. 
       end do 
      end do 
                                                                        
      bgcolor='LightYellow'//ch0 
      fgcolor='black'//ch0 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//ch0 
      do j=1,maxsub 
       ncolor(j)=icolor_sub(j) 
      end do 
                                                                        
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=name_data 
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if 
!      write(6,'(2a)')'datfile=',datfile(1:60)                          
                                                                        
      if(.not.b_data) title=name_theory 
      nresidue=0 
      if(base.eq.0.) base=1. 
                                                                        
!      write(6,'(a,3f10.3)') ' velo(1,512)=',velocity(1),               
!     &                 velocity(256),velocity(512)                     
!      write(6,'(a,3f10.3)') ' geof(1,512)=',geof(1),geof(256),geof(512)
!        do j=240,250                                                   
!         write(6,'(i4,4x,f15.6)') j,thfk(j)                            
!       end do                                                          
                                                                        
                                                                        
       ny=0 
       nyy=0 
       do ii=1,infplot 
        nchanplot(ii)=0 
       end do 
       basepl=base 
       if(ndisplay_mode.ge.5) basepl=1 
                                                                        
       if(b_data) then 
        nbegin=0 
        i=0 
        do while(nbegin.eq.0.and.i.lt.nchansp) 
         i=i+1 
         if(b_datf(i)) nbegin=i 
        end do 
        nend=0 
        i=nchansp+1 
        do while(nend.eq.0.and.i.gt.1) 
         i=i-1 
         if(b_datf(i)) nend=i 
        end do 
        do i=1,nchansp 
         varray(i)=velocity(i) 
        end do 
        varray(nchansp+1)=varray(1) 
        varray(nchansp+2)=varray(2) 
                                                                        
        is1=sign(1.,varray(nbegin+1)-varray(nbegin)) 
        do ii=nbegin+1,nend 
                                                                        
         is2=sign(1.,varray(ii+1)-varray(ii)) 
!         write(6,'(i4,f10.4)')is2,varray(ii)                           
         if(is1*is2.lt.0) goto 9 
        end do 
    9   continue 
                                                                        
                                      ! double valued spectrum          
        nsinglev=1 
                                      ! single valued  ''               
        if(ii.gt.nend-2) nsinglev=-1 
        basepl=base 
        if(ndisplay_mode.ge.5)then 
         basepl=1 
         if(nsinglev.eq.1)basepl=0.5 
        end if 
                                                                        
!        write(6,'(a,2i6)') ' ndisplay_mode=',ndisplay_mode,nchansp     
!        write(6,'(3(a,i7))') ' mfpt=',mfpt,' mdfpt=',mdfpt,            
!     & '  sigle_v=',nsinglev                                           
                                                                        
        b_vdarray=.false. 
        if(ndisplay_mode.ge.3) then 
                                                                        
         if(nsinglev.lt.0) then 
          do ii=nbegin,nend 
           if(b_datf(ii)) then 
            ny=ny+1 
            plotx(ny)=velocity(ii) 
            ploty(ny)=real_fr(mfpt+ii)/basepl 
            ploterry(ny)=real_fr(mdfpt+ii)/basepl 
           end if 
          end do 
                                                                        
          if(b_theory) then 
           do ii=nbegin,nend 
            nyy=nyy+1 
            plotxx(nyy)=velocity(ii) 
            plotyy(nyy)=thfk(ii)/basepl 
           end do 
                                                                        
           if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6) then 
            nresidue=1 
            ns=0 
            do ii=nbegin,nend 
             if(b_datf(ii)) then 
              ns=ns+1 
              plotres(ns)=ploty(ii)-plotyy(ii) 
             end if 
            end do 
           end if 
                                                                        
           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j)/basepl 
             end do 
            end do 
           end if 
                   ! b_theory                                           
          end if 
          goto 200 
                   !  nsinglev < 0                                      
         end if 
                                                                        
         sqrt2=sqrt(2.) 
         base2=2*basepl 
                                                                        
         l=3*int(log10(abs(v_max/nchansp*4.))*2.) 
         glow=10**l 
!        write(6,'(a,i4)') ' lower limit =',l                           
         if(b_theory) then 
          do i=1,nchansp 
           yyarray(i)=thfk(i)/geof(i) 
          end do 
          yyarray(nchansp+1)=thfk(1)/geof(1) 
          yyarray(nchansp+2)=thfk(2)/geof(2) 
         end if 
         if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6) nresidue=1 
                                                                        
         do i=1,nchansp 
          resarray(i)=real_fr(mfpt+i)-thfk(i) 
          yarray(i)=real_fr(mfpt+i)/geof(i) 
         end do 
         yarray(nchansp+1)=real_fr(mfpt+1)/geof(1) 
         yarray(nchansp+2)=real_fr(mfpt+2)/geof(2) 
                                                                        
         nh=nchansp/2. 
         irh=int(fold_point)+1 
         il=irh 
         do ii=irh,irh+nh-1 
          ir=ii 
          if(ir.gt.nchansp) ir=ir-nchansp 
          il=il+1 
          vir=varray(ir) 
          ivd=1 
          il1=il+1 
          vil1=varray(il+1) 
          vil=varray(il) 
          do while(ivd.gt.0) 
           il2=il1 
           il1=il 
           vil2=vil1 
           vil1=vil 
           ivd=1 
                                                                        
           if(vil2-vir.le.0)  ivd=-1 
           if(vil2-vir.eq.0) goto 18 
                                                                        
           if(vil1-vir.lt.0) then 
            ivd=-ivd 
           else if(vil1-vir.eq.0) then 
            ivd=-1 
           end if 
                                                                        
   18      il=il-1 
           if(il.lt.1) il=il+nchansp 
           vil=varray(il) 
                                                                        
                                                                        
          end do 
          v1=vil-vil1 
          v3=vil2-vil1 
          vr=vir-vil1 
          if(b_theory) then 
           nyy=nyy+1 
           irarray(nyy)=ir 
           i0array(nyy)=il 
           i1array(nyy)=il1 
           i2array(nyy)=il2 
           v1array(nyy)=v1 
           v3array(nyy)=v3 
           vrarray(nyy)=vr 
           vdarray(nyy)=0. 
                                                                        
           v1mv3=v1-v3 
           det=v1*v3*v1mv3 
           if(abs(det).gt.glow) then 
            vdarray(nyy)=det 
            b_vdarray=.true. 
            y1=yyarray(il) 
            y2=yyarray(il1) 
            y3=yyarray(il2) 
            y1=y1-y2 
            y3=y3-y2 
            y1=y1*v3 
            y3=y3*v1 
            aa=y1-y3 
            bb=-y1*v3+y3*v1 
            ff=vr*(vr*aa+bb)/det+y2 
           else 
            ff=yyarray(il1) 
            b_vdarray=.false. 
           end if 
           plotxx(nyy)=vir 
           plotyy(nyy)=(yyarray(ir)+ff)/base2 
          else 
           b_vdarray=.false. 
                  ! b_theory                                            
          end if 
                                                                        
          if(b_datf(ir)) then 
           y1=yarray(il) 
           y2=yarray(il1) 
           y3=yarray(il2) 
           if(y1.ne.0..and.y2.ne.0..and.y3.ne.0.) then 
            ny=ny+1 
            iiii=ny/64 
            if(b_vdarray) then 
             y1=y1-y2 
             y3=y3-y2 
             y1=y1*v3 
             y3=y3*v1 
             aa=y1-y3 
             bb=-y1*v3+y3*v1 
             ff=vr*(vr*aa+bb)/det+y2 
!            if(iiii*64.eq.ny) write(6,'(a,i4,f15.5)')                  
!    &       ' b_vdarray=true ny,ff=',ny,ff                             
            else 
             ff=y2 
!            if(iiii*64.eq.ny) write(6,'(a,i4,f15.5)')                  
!    &       ' b_vdarray=false ny,ff=',ny,ff                            
            end if 
            plotx(ny)=vir 
            ploty(ny)=(abs(yarray(ir))+abs(ff))/base2 
            ploterry(ny)=sqrt2*real_fr(mdfpt+ir)/base2 
            if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6)                &
     &                         plotres(ny)=resarray(ir)/base2           
!           if(iiii*64.eq.ny) write(6,'(2(a,i4,f15.5))')                
!     & '   ny,plotres(ny)=',ny,plotres(ny),' ir,basepl=',ir,basepl     
           end if 
          end if 
         end do 
!        ny plot points for the data                                    
!        nyy plot points for the theory                                 
                                                                        
         if(b_theory.and.n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           do i=1,nchansp 
            yyarray(i)=subspectrum(i,j) 
           end do 
           yyarray(nchansp+1)=yyarray(1) 
           yyarray(nchansp+2)=yyarray(2) 
                                                                        
           ns=(j-1)*max8 
           nchanplot(6+j)=nh 
           do ii=1,nh 
            v1=v1array(ii) 
            v3=v3array(ii) 
            vr=vrarray(ii) 
            det=vdarray(ii) 
            ir=irarray(ii) 
            il0=i0array(ii) 
            il1=i1array(ii) 
            il2=i2array(ii) 
            if(det.ne.0.) then 
             y1=yyarray(il0) 
             y2=yyarray(il1) 
             y3=yyarray(il2) 
             y1=y1-y2 
             y3=y3-y2 
             y1=y1*v3 
             y3=y3*v1 
             aa=y1-y3 
             bb=-y1*v3+y3*v1 
             ff=vr*(vr*aa+bb)/det+y2 
            else 
             ff=yyarray(il1) 
            end if 
            ns=ns+1 
            plotsub(ns)=(subspectrum(ir,j)+ff)/base2 
           end do 
          end do 
         end if 
                 ! ndisplay_mode.ge.3                                   
        else 
         do i=nbegin,nend 
          if(b_datf(i)) then 
           ny=ny+1 
           plotx(ny)=i 
           ploty(ny)=real_fr(mfpt+i) 
           ploterry(ny)=real_fr(mdfpt+i) 
          end if 
         end do 
                                                                        
         if(b_theory) then 
!          do i=nbegin,nend                                             
          do i=1,nchansp 
           nyy=nyy+1 
           plotyy(nyy)=thfk(i) 
           plotxx(nyy)=i 
          end do 
          if(ndisplay_mode.eq.2) then 
           nresidue=1 
           ns=0 
           do ii=nbegin,nend 
            if(b_datf(ii)) then 
             ns=ns+1 
             plotres(ns)=real_fr(mfpt+ii)-thfk(ii) 
            end if 
           end do 
          end if 
          if(n_subspectra.gt.0) then 
           do j=1,n_subspectra 
            ns=(j-1)*max8 
            nchanplot(6+j)=nend-nbegin+1 
            do ii=1,nchansp 
             ns=ns+1 
             plotsub(ns)=subspectrum(ii,j) 
            end do 
           end do 
          end if 
                 ! b_theory                                             
         end if 
                 ! ndisplay_mode.ge.3                                   
        end if 
             ! b_data                                                   
       else 
                                                                        
        if(ndisplay_mode.ge.3) then 
         nyy=nchansp/2 
         do i=1,nyy 
          plotxx(i)=velocity(i) 
          plotyy(i)=thfk(i)/basepl/geof(i) 
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do i=1,nyy 
            plotsub(ns+i)=subspectrum(i,j)/basepl/geof(i) 
           end do 
          end do 
         end if 
        else 
         nyy=nchansp 
         do i=1,nchansp 
          plotxx(i)=nyy-i+1 
          plotyy(i)=thfk(i) 
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do i=1,nyy 
            plotsub(ns+i)=subspectrum(i,j) 
           end do 
          end do 
         end if 
        end if 
              ! b_data                                                  
       end if 
                                                                        
  200 continue 
                                                                        
      xmin=1.e30 
      xmax=-xmin 
      ymin=xmin 
                                    ! counts > 0                        
      ymax=0. 
      if(b_data) then 
       do ii=1,3 
        nchanplot(ii)=ny 
       end do 
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny 
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i) 
       end do 
       do i=1,ny 
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i) 
       end do 
      end if 
      if(b_theory) then 
       nchanplot(5)=nyy 
       nchanplot(6)=nyy 
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy 
        if(ymin.gt.plotyy(i))ymin=plotyy(i) 
       end do 
       do i=1,nyy 
        if(ymax.lt.plotyy(i))ymax=plotyy(i) 
       end do 
      end if 
                                                                        
      if(nresidue.eq.1.and.b_theory) then 
        nchanplot(4)=ny 
        resmin=0. 
        resmax=0. 
        do i=1,ny 
         hd= plotres(i)-ploterry(i) 
         if(resmin.gt.hd) resmin=hd 
        end do 
        do i=1,ny 
         hd= plotres(i)+ploterry(i) 
         if(resmax.lt.hd) resmax=hd 
        end do 
         hd= resmax-2.0*resmin 
        do i=1,ny 
         plotres(i)=plotres(i)+ymax-resmin 
        end do 
        ymax=ymax-resmin+resmax 
                                                                        
      end if 
       xyzdz(1)=xmin 
       xyzdz(2)=xmax 
       xyzdz(3)=ymin 
       xyzdz(4)=ymax 
                                                                        
       b_logx=.false. 
       b_logy=.false. 
       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1 
                                                                        
!      definitions taken from allplo                                    
                               ! (none,Both,bottom,top)  [B]            
       chx='b' 
                               ! (none,bottom,top)  [n]                 
       chbx='n' 
                               ! (left,right)  [r]                      
       chlr='l' 
                               ! (none,Both,left,right)  [B]            
       chy='l' 
                               ! (none,left,right)  [r]                 
       chby='l' 
                               ! (bottom,top)  [t]                      
       chbt='b' 
                               !                                        
       chh=0.3 
                               ! character cw,ch  [0.40,0.40]           
       chw=0.25 
                               !                                        
       syw=0.1 
                               ! symbol sw,sh     [0.40,0.40]           
       syh=0.1 
                               ! color frame       [black]              
       frcolor=fgcolor 
       frcolor='blue'//ch0 
       CTEXT=title 
       CXTEXT=abscissa 
       CYTEXT=ordinata 
                                                                        
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
     &            chh,chw,syw,syh,                                      &
     &          CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)      
                                                                        
!      write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax             
!      write(6,'(a,10i5)') ' nchanplot=',(nchanplot(ii),ii=1,8)         
!      write(6,'(2(a,i4))')  ' ny=',ny,'    nyy=',nyy                   
!      write(6,'(a)')  ' j,plotx(j),ploty(j)'                           
!      write(6,'(3(2x,i4,1x,2g12.4))') (j,plotx(j),ploty(j),j=1,ny,16)  
!      write(6,'(a)')  ' j,plotres(j),ploty(j)'                         
!      write(6,'(3(2x,i4,1x,2g10.2))') (j,plotres(j),ploty(j),j=1,ny,16)
                                                                        
      return 
      END                                           
                                                                        
      subroutine drive(mode_drive) 
      use glbconst, only: maxn,icstrf,ivstrf
      use comdat, only: b_data,mxpt
      use comthe, only: real_fr                                                                        
      implicit none
      integer,intent(in):: mode_drive                                                                
      logical mode_nlin
      real          dum1,channels,dum2,channels_vmax,dumcsp  
      common/acstrf/dum1(5),                                            &
                    channels,dum2(4),channels_vmax,dumcsp(icstrf-11)       
      real          avsp,f_factor,base,bg_fraction,v_max,channel_v0,    &
                    v_max2,vphase2,v_max3,vphase3,geo,dumvsp                                                            
      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,               &
                    channel_v0,v_max2,vphase2,v_max3,vphase3,geo,       &
                    dumvsp(ivstrf-11)                                         
                                                                        
      real          velocity,geof,dfdgeo 
      common/adrive/velocity(maxn),geof(maxn),dfdgeo(maxn) 
      real          arg,c1,c2,c2p,c3p,c4,c5,cp,cx,fold_point,           &
                    fold_point2,fold_point3,fptmchpd,fptmpdh,fptpchpd,  &
                    fptppdh,period2,s,sx,vh,vmax_chan,x
      integer       nchansp,ii,iperiod                                                                    
      nchansp=channels 
                                                                        
!      write(6,'(a,f10.3)') ' ****--------*******drive v_max=',v_max    
!      write(6,'(a,2f10.3)') ' drive_mode,channels_vmax=',              
!     &                        drive_mode,channels_vmax                 
!     calculation  of velocity ,geo, dfdgeo                             
!     nchen mode = +1   triangular wave mode                            
!     nchen mode = +2   sine wave mode                                  
!     nchen mode = +3   triangular wave mode with cosine correction :   
!                   x = x - vmax2*cos(c2p*(x-fold_point2))-             
!                           vmax3*cos(c2p*(x-fold_point3))-             
!     nchen mode = +4   sine wave mode with cosine correction :         
!                   x = x - vmax2*cos(c2p*(x-fold_point2))-             
!                           vmax3*cos(c2p*(x-fold_point3))-             
!                                                                       
!      write(6,'(a,i4,5f10.3)') ' drive mode_drive,v_max=',             
!     &                     mode_drive,v_max,channels_vmax,channel_v0   
                                                                        
                                                                        
      iperiod=channels_vmax*2.0 
      mode_nlin=.true. 
      cp=3.141592/channels_vmax/2.0 
      c2p=2.0*cp 
      c3p=3.0*cp 
      fold_point=channel_v0+channels_vmax 
      fold_point2=vphase2+channels_vmax*2.0 
      fold_point3=vphase3+channels_vmax*2.0 
      if(mode_drive.eq.3.and..not.b_data)goto 100 
      goto (10,100,200,100,1000),mode_drive 
                                                                        
!     triangular wave                                                   
                                                                        
   10 continue 
                                                                        
      period2=channels_vmax*4.0 
      fptmchpd=channel_v0-channels_vmax 
      fptpchpd=channel_v0+channels_vmax*3.0 
      fptmpdh =channel_v0 
      fptppdh =channel_v0+channels_vmax*2.0 
      vmax_chan=v_max/channels_vmax 
                                                                        
!      a step in the function geof at v_max vanishes with the           
!      transformation of v_max 2007                                     
       v_max=v_max+v_max2*cos(c2p*(fold_point-fold_point2))+            &
     &             v_max3*cos(c3p*(fold_point-fold_point3))             
                                                                        
      do ii=1,nchansp 
       x=ii 
       if(x-fold_point.gt.0.)goto 30 
!      left side                                                        
       if(x.gt.fptmchpd) goto 22 
       x=x+period2 
       goto 32 
   22  c1=fptmpdh-x 
       s=1. 
       goto 40 
!      right side                                                       
   30  if(x.lt.fptpchpd) goto 32 
       x=x-period2 
       goto 22 
   32  c1=fptppdh-x 
       s=-1. 
   40  c4=s*vmax_chan 
       vh=c4*c1 
       if(mode_nlin) vh=vh-v_max2*cos(c2p*(x-fold_point2))-             &
     &                     v_max3*cos(c3p*(x-fold_point3))              
       velocity(ii)=vh 
       cx=vh/v_max 
       c2=s*(cx**2-1.) 
       c5=1.+geo*c2 
       geof(ii)=1./c5**2 
       dfdgeo(ii)=-2.*geof(ii)/c5*c2 
!       if(ii.gt.fold_point-2.and.ii.lt.fold_point+2)                   
!     & write(6,'(i5,a,3f12.4)')ii,' vh,v_max,geof=',vh,v_max,geof(ii)  
      end do 
      goto 1000 
!                                                                       
!     sine wave                                                         
!                                                                       
  100 continue 
      do ii=1,nchansp 
       x=ii 
       arg=cp*(x-fold_point) 
       vh=-v_max*cos(arg) 
       if(mode_nlin) vh=vh-v_max2*cos(c2p*(x-fold_point2))-             &
     &                   v_max3*cos(c3p*(x-fold_point3))                
       velocity(ii)=vh 
                                                                        
       sx=sin(arg) 
       c5=1.+geo*sx 
       geof(ii)=1./c5**2 
       dfdgeo(ii)=-2.*geof(ii)/c5*sx 
      end do 
      goto 1000 
                                                                        
                          !    mode_drive=3                             
  200 continue 
      do ii=1,nchansp 
       vh=real_fr(mxpt+ii) 
       if(mode_nlin) vh=vh-v_max2*cos(c2p*(x-fold_point2))-             &
     &                     v_max3*cos(c3p*(x-fold_point3))              
       velocity(ii)=vh 
       cx=vh/v_max 
       c2=(cx**2-1.) 
       c5=1.+geo*c2 
       geof(ii)=1./c5**2 
       dfdgeo(ii)=-2.*geof(ii)/c5*c2 
      end do 
 1000 continue 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
     subroutine geometry(ichansp,cosa,a_R,jt) 
     use glbconst, only: maxn,icstrf,ivstrf,enwr,nwr
     implicit none 
                                                                       
     integer ichansp,jt,icase,N_S,N_B 
     real    r_B,r_S,sumi0,SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF 
     common/geomet/icase,N_S,N_B,r_B,r_S,sumi0,                        &
                   SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF       
                                                                       
     real       dum1,channels,dum2,channels_vmax,flag_basis,           &
                om_samp,Dsource,Dabsorber,                             &
                sc2absorber,sc2aperture,dumcs                          
     common/acstrf/ dum1(5),                                           &
              channels,dum2(4),channels_vmax,flag_basis,               &
              om_samp,Dsource,Dabsorber,                               &
              sc2absorber,sc2aperture,dumcs(icstrf-17)                 
                                                                       
     real    avsp,f_factor,base,bg_fraction,v_max,                     &
             channel_v0,v_max2,vphase2,v_max3,vphase3,                 &
             geo,Daperture,d_absorber,d_source,dumvs                   
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,               &
             channel_v0,v_max2,vphase2,v_max3,vphase3,geo,             &
             Daperture,d_absorber,d_source,dumvs(ivstrf-14)            
!    d_absorber is the deviation from the axis: center of the source to
!    center aperture of the detector.                                  
!    d_source is the deviation from the axis: center of the absorber to
!    center aperture of the detector.                                  
     real   BoverFd,AoverFd,SoverFd,HoverFd,DAoverFd,DSoverFd,         &
            sc2apertured,gdetectord,geod                               
     common/geom/  BoverFd,AoverFd,SoverFd,HoverFd,DAoverFd,DSoverFd,  &
                   sc2apertured,gdetectord,geod                          
     integer       i,j,nB,nR,nS,jR 
     real          velocity,geof,dfdgeo 
     common/adrive/velocity(maxn),geof(maxn),dfdgeo(maxn) 
                                                                       
     real          w_R,RR,RoverF,cc,h,hh,h0,h1,xi,xi2,yi,v2,kx,ky,k2,  &
                   tau,tau2,maxtau,mintau,cyp_max,cym_min,gdetector             
                                                                       
     real,dimension(1320):: cosa,a_R
     real,parameter :: r4=3.0, r11=4.4641, r20=6.2915, r33=8.2111 
                                                                       
!    number 1,5,6,21,22 are of half weight                             
!    1-4 (r=3), 1-11 (2*sq3+1), 1-20 (2*sq7+1) 1-33 (2*sq13+1)         
     real,dimension(66)  :: &
        xy=(/0.0, 0.000,1.0, 1.732,1.0,-1.732,2.0, 0.000,              &
             0.0, 3.464,0.0,-3.464,2.0, 3.464,2.0,-3.464,              &
             3.0, 1.732,3.0,-1.732,4.0, 0.000,                         &
             1.0, 5.196,1.0,-5.196,3.0, 5.196,3.0,-5.196,              &
             4.0, 3.464,4.0,-3.464,5.0, 1.732,5.0,-1.732,              &
             6.0, 0.000,                                               &
             0.0, 6.928,0.0,-6.928,2.0, 6.928,2.0,-6.929,              &
             4.0, 6.928,4.0,-6.928,5.0, 5.196,5.0,-5.196,              &
             6.0, 3.464,6.0,-3.464,7.0, 1.732,7.0,-1.732,              &
             8.0, 0.000/)                                               
     real,dimension(33)  :: &
      wt=(/0.5,1.,1.,1.,0.5,0.5,1. ,1. ,1.,1.,1.,1.,1.,1.,           &
             1., 1.,1.,1.,1. ,1. ,0.5,0.5,1.,1.,1.,1.,1.,1.,           &
             1., 1.,1.,1.,1./)                                          
                                                                       
!     om_samp             :    constant                 [0]             
!     Dsource             :    constant                 [0.5]           
!     Dabsorber           :    constant from experiment [1.6]           
!     Daperture           :    constant from experiment [2.5]           
!     F=sc2aperture       :    constant from experiment [10.0]          
!     H=sc2absorber       :    parameter                [5.0]           
!     d_absorber          :    parameter                [0.0]           
!     d_source            :    parameter                [0.0]           
!     geo                 :    parameter                [0.00000]       
                                                                        
                                                                        
!     10 different cases of the geometry                                
!     uvwx   , 0 dynamically decided                                    
!     u=1,2 point/extended source                                       
!     v=1,2 intersection/full image or aperture                         
!     w=1,2 image of the absorber/ aperture                             
!     x=1,2 alignment/misalignment                                      
      gdetector=6. 
      if(icase.gt.0) goto 10 
      N_B=om_samp+1 
                                                                        
      SoverF=Dsource/sc2aperture 
      AoverF=Dabsorber/sc2aperture 
      BoverF=Daperture/sc2aperture 
                                                                        
      DAoverF=d_absorber/sc2aperture 
      DSoverF=d_source/sc2aperture 
      HoverF=sc2absorber/sc2aperture 
!        write(6,'(a,8f10.3)')' Ds,Da,Dap,d_s,d_a,sab,sap=',            
!     &  Dsource,Dabsorber,Daperture,d_source,d_absorber,               
!     &  sc2absorber,sc2aperture                                        
                                                                        
      BoverFd=BoverF 
      AoverFd=AoverF 
      SoverFd=SoverF 
      HoverFd=HoverF 
      DAoverFd=DAoverF 
      DSoverFd=DSoverF 
      sc2apertured=sc2aperture 
      gdetectord=gdetector 
      geod=abs(geo) 
!        write(6,'(a,i3,2x,6f10.3)')' N_B,S,A,B,DA,H/F=',               
!     &  N_B,SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF                
                                                                        
      tau=1.0/(1.0-sqrt(geof(ichansp))*(1-HoverF)) 
      tau2=tau**2 
      maxtau=(1-geo)/(HoverF-geo) 
      mintau=(1+geo)/(HoverF+geo) 
      if(SoverF.le.0.0001) then 
!      case of point source                                             
       if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then 
!       alignment                                                       
!       case=1001                                                       
        icase=1 
                                                                        
        i=0 
        RR=AoverF/2.0 
        if(RR*tau.lt.BoverF/2.) then 
         w_R=RR/N_B 
        sumi0=1. 
        jr=1. 
        do nR=2,N_B 
         RoverF=(nR-0.5)*w_R 
         jr=jr+2 
         h=1.0/(1.0+(RoverF/HoverF)**2) 
         sumi0=sumi0+ h*sqrt(h)*jr 
        end do 
!           write(6,'(a,10f10.5)')                                      
!     &  'a  sumi0,tau,AoverF,BoverF,w_R=',sumi0,tau,AoverF,BoverF,w_R  
             ! RR.gt.BoverF/2.                                          
        else 
         w_R=BoverF/2./N_B 
        sumi0=1. 
        jr=1. 
        do nR=2,N_B 
         RoverF=(nR-0.5)*w_R 
         jr=jr+2 
         h=1.0/(1.0+RoverF**2) 
         sumi0=sumi0+ h*sqrt(h)*jr 
        end do 
!           write(6,'(a,10f10.5)')                                      
!     &  'b  sumi0,tau,AoverF,BoverF,w_R=',sumi0,tau,AoverF,BoverF,w_R  
        end if 
!         enwr(9)='plot'                                                
        if(enwr(9).eq.'plot') then 
         write(nwr,'(a)')'point source/alignment icase=1' 
         if(RR*maxtau.le.BoverF/2) then 
          write(nwr,'(a)')                                              &
     &            'image of absorber is smaller than/equal aperture'    
         else if(RR*mintau.gt.BoverF/2) then 
          write(nwr,'(a)')'image of absorber is larger than aperture' 
         else if(RR*mintau.lt.BoverF/2.and.RR*maxtau.gt.BoverF/2) then 
          write(nwr,'(a,/a)')'**warning** absorber image/aperture <> 1',&
     &    ' depends on the position of the source'                      
         end if 
         call geompointsc 
         enwr(9)='nnnn' 
        end if 
             ! abs(DAoverF)+abs(DSoverF)> 0                             
       else 
!       misalignment                                                    
                                                                        
        h=DAoverF-DSoverF+AoverF/2. 
        if(h.gt.0)then 
         cyp_max=DSoverF+h*maxtau 
        else 
         cyp_max=DSoverF+h*mintau 
        end if 
        h=DAoverF-DSoverF-AoverF/2. 
        if(h.gt.0)then 
         cym_min=DSoverF+h*mintau 
        else 
         cym_min=DSoverF+h*maxtau 
        end if 
                                                                        
        sumi0=0.0 
        if(cyp_max.le.BoverF/2..and.cym_min.ge.-BoverF/2.)then 
!        Intersection is the full image of the absorber                 
!        case=1212                                                      
         if(enwr(9).eq.'plot') then 
          write(nwr,'(a,2(/,a))')' point source/misalignment icase=2',  &
     &    ' image of the absorber inside aperture',                     &
     &    ' integration over image by circles'                          
          call geompointsc 
          enwr(9)='nnnn' 
         end if 
                                                                        
         icase=2 
         RR=AoverF/2.0 
         if(N_B.le.4)then 
          N_B=4 
          r_B=RR/r4 
         else if(N_B.le.11)then 
          N_B=11 
          r_B=RR/r11 
         else if(N_B.le.20)then 
          N_B=20 
          r_B=RR/r20 
         else if(N_B.gt.20)then 
          N_B=33 
          r_B=RR/r33 
         end if 
                                                                        
         i=-1 
         do nB=1,N_B 
          i=i+2 
          xi=xy(i)*r_B 
          yi=DAoverF-DSoverF+xy(i+1)*r_B 
          h=1.0/(1.0+(xi**2+yi**2)*tau2) 
          sumi0=sumi0+h*sqrt(h)*wt(nB) 
         end do 
!        write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau                   
        else if(cyp_max.gt.BoverF/2..and.cym_min.lt.-BoverF/2.)then 
!        Intersection is the full aperture                              
!        case=1222                                                      
         if(enwr(9).eq.'plot') then 
          write(nwr,'(a,2(/,a))')' point source/misalignment icase=3',  &
     &  ' image of the absorber larger than aperture',                  &
     &  ' integration over aperture by circles'                         
          call geompointsc 
          enwr(9)='nnnn' 
         end if 
                                                                        
         icase=3 
!         write(6,'(a,5f12.3)')'mintau,maxtau,cyp_max,cym_min,BoverF/2='
!     &                         mintau,maxtau,cyp_max,cym_min,BoverF/2  
         RR=BoverF/2.0 
         if(N_B.le.4)then 
          N_B=4 
          r_B=RR/r4 
         else if(N_B.le.11)then 
          N_B=11 
          r_B=RR/r11 
         else if(N_B.le.20)then 
          N_B=20 
          r_B=RR/r20 
         else if(N_B.gt.20)then 
          N_B=33 
          r_B=RR/r33 
         end if 
         i=-1 
         do nB=1,N_B 
          i=i+2 
          xi=xy(i)*r_B 
          yi=-DSoverF+xy(i+1)*r_B 
          h=1.0/(1.0+xi**2+yi**2) 
          sumi0=sumi0+h*sqrt(h)*wt(nB) 
         end do 
!        write(6,'(a,10f10.3)')'sumi0=',sumi0                           
        else 
!        Intersection; image of the absorber filled with cirles         
!        case=1112                                                      
         if(enwr(9).eq.'plot') then 
          write(nwr,'(a,3(/,a))')' point source/misalignment icase=4',  &
     &  ' intersection of absorber image and aperture depends on the',  &
     &  ' position of the source; integration over aperture by circles',&
     &  ' with smooth edge'                                             
          BoverFd=-BoverFd 
          call geompointsc 
          enwr(9)='plot' 
         end if 
                                                                        
         RR=AoverF/2.0 
         icase=4 
         RR=AoverF/2. 
         if(N_B.le.4)then 
          N_B=20 
          r_B=RR/r20 
         else if(N_B.gt.4)then 
          N_B=33 
          r_B=RR/r33 
         end if 
                                                                        
         i=-1 
         do nB=1,N_B 
          i=i+2 
          xi2=(xy(i)*r_B*tau)**2 
          yi=(DAoverF-DSoverF+xy(i+1)*r_B)*tau 
          h=1.0/(1.0+(xi2+yi**2)) 
          hh=h*sqrt(h)*wt(nB) 
          cc=sqrt(xi2+(DSoverF+yi)**2)/BoverF*8.-3. 
          if(cc.gt.0.) then 
!         image out of aperture cirle (decreasing weight)               
           hh=hh*exp(-(cc*gdetector)**2) 
          end if 
          sumi0=sumi0+hh 
!         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau                  
         end do 
        end if 
       end if 
                  ! Dsource > 0                                         
      else 
!      ################## extended source ############################  
!     v=1,2 intersection/full image or aperture                         
!     w=1,2 image of the absorber/ aperture                             
!     x=1,2 alignment/misalignment                                      
                                                                        
       sumi0=0.0 
       tau=1.0/(1.0-sqrt(geof(ichansp))*(1-HoverF)) 
       tau2=tau**2 
                                                                        
       if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then 
!       alignment                                                       
!       case=2001                                                       
        icase=5 
                                                                        
        h=AoverF-SoverF 
        if((h.gt.0.0.and.SoverF+h*mintau.gt.BoverF).or.                 &
     &     (h.lt.0.0.and.SoverF+h*maxtau.gt.BoverF)) then               
!        image covers aperture for all source points                    
!        integration over aperture (rings), source circles              
!        2221                                                           
         icase=5 
         if(enwr(9).eq.'plot') then 
          write(nwr,'(a,2(/,a))')' extended source/alignment icase=5',  &
     &    ' image covers aperture for all source points',               &
     &    ' integration over aperture by rings and source by circles'   
          call geomextendsc 
          enwr(9)='nnnn' 
         end if 
                                                                        
         RR=SoverF/2. 
         if(N_B.le.4)then 
          N_S=4 
          r_S=RR/r4 
         else if(N_B.le.11)then 
          N_S=11 
          r_S=RR/r11 
         else if(N_B.gt.11)then 
          N_S=20 
          r_S=RR/r20 
!         else if(N_B.gt.20)then                                        
!         N_S=33                                                        
!         r_S=RR/r33                                                    
!         never more than 20 circles for the source=> less than 20*20 va
         end if 
                                                                        
         w_R=BoverF/2.0/N_B 
         jR=-1 
         do nR=1,N_B 
          RoverF=(nR-0.5)*w_R 
          jR=jR+2 
          i=-1 
          do nS=1,N_S 
           i=i+2 
           v2=(xy(i)*r_S)**2+(RoverF-xy(i+1)*r_S)**2 
           h=1./(1.+v2) 
           sumi0=sumi0+h*sqrt(h)*wt(nS)*jR 
!           write(6,'(2i4,a,6f12.3)')nS,nR,' sqrt(h)=',                 
!     &        sqrt(h),wt(nS),RoverF*sc2aperture                        
          end do 
         end do 
!         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau                  
        else 
         h=AoverF+SoverF 
         if(-SoverF+(AoverF+SoverF)*maxtau.lt.BoverF) then 
         if(enwr(9).eq.'plot') then 
          write(nwr,'(a,2(/,a))')' extended source/alignment icase=6',  &
     &    ' image inside aperture for all source points',               &
     &    ' integration over image, source by rings/image by circles'   
          call geomextendsc 
          enwr(9)='nnnn' 
         end if 
!         2211                                                          
          icase=6 
                                                                        
          RR=AoverF/2. 
          if(N_B.le.4)then 
           N_B=4 
           r_B=RR/r4 
          else if(N_B.le.11)then 
           N_B=11 
           r_B=RR/r11 
          else if(N_B.le.20)then 
           N_B=20 
           r_B=RR/r20 
          else if(N_B.gt.20)then 
           N_B=33 
           r_B=RR/r33 
          end if 
                                                                        
          tau2=tau**2 
          w_R=SoverF/2.0/N_B 
          jR=-1 
          do nS=1,N_B 
           RoverF=(nS-0.5)*w_R 
           jR=jR+2 
           i=-1 
           do nB=1,N_B 
            i=i+2 
            kx=xy(i)*r_B 
            ky=-RoverF+xy(i+1)*r_B 
            h=1.0/(1.0+(kx**2+ky**2)*tau2) 
            sumi0=sumi0+h*sqrt(h)*wt(nB)*jR 
           end do 
          end do 
              ! general case of an alignment                            
         else 
          if(enwr(9).eq.'plot') then 
           write(nwr,'(a,2(/,a))')' extended source/alignment icase=7', &
     &    ' source source/aperture <> 1 dependent on source position',  &
     &    ' integration over aperture (by circles) with smooth edge'    
          BoverFd=-BoverFd 
          call geomextendsc 
          enwr(9)='nnnn' 
         end if 
!         2111                                                          
          icase=7 
                                                                        
          w_R=SoverF/2.0/N_B 
          jR=-1 
          do nS=1,N_B 
           RoverF=(nS-0.5)*w_R 
           jR=jR+2 
           i=-1 
           do nB=1,N_B 
            i=i+2 
            kx=xy(i)*r_B 
            ky=-RoverF+xy(i+1)*r_B 
            h=1.0/(1.0+(kx**2+ky**2)*tau2) 
            hh=h*sqrt(h)*wt(nB)*jR 
            cc=sqrt((tau*xy(i)*r_B)**2+                                 &
     &              (RoverF*(1.-tau)+tau*xy(i+1)*r_B)**2)/BoverF*8.-3.  
            if(cc.gt.0.0) then 
             hh=hh*exp(-(cc*gdetector)**2) 
            end if 
            sumi0=sumi0+hh 
           end do 
          end do 
!         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau                  
         end if 
        end if 
                                                                        
             ! abs(DAoverF)+abs(DSoverF)> 0                             
       else 
        if(enwr(9).eq.'plot') then 
         write(nwr,'(a,2(/,a))')                                        &
     &    ' extended source/misalignment icase=8',                      &
     &    ' integration by cirles (source and aperture)',               &
     &    ' aperture with smooth edge'                                  
         BoverFd=-BoverFd 
         call geomextendsc 
         enwr(9)='nnnn' 
        end if 
!       2122                                                            
        icase=8 
        RR=SoverF/2. 
        if(N_B.le.4)then 
         N_S=4 
         r_S=RR/r4 
        else if(N_B.le.11)then 
         N_S=11 
         r_S=RR/r11 
        else if(N_B.gt.11)then 
         N_S=20 
         r_S=RR/r20 
!        else if(N_B.gt.20)then                                         
!        N_S=33                                                         
!        r_S=RR/r33                                                     
!        never more than 20 circles for the source=> less than 20*33 val
        end if 
                                                                        
        RR=AoverF/2. 
        if(N_B.le.4)then 
         N_B=20 
         r_B=RR/r20 
        else if(N_B.gt.4)then 
         N_B=33 
         r_B=RR/r33 
        end if 
        jt=0 
        j=-1 
        do nS=1,N_S 
         j=j+2 
         xi=xy(j)*r_S 
         yi=xy(j+1)*r_S+DSoverF 
 2200    i=-1 
         do nB=1,N_B 
          i=i+2 
          jt=jt+1 
          k2=(xy(i)*r_B-xi)**2+(xy(i+1)*r_B+DAoverF-yi)**2 
          h=1./(1.+k2*tau2) 
          hh=h*sqrt(h)*wt(nS) 
          h1=sqrt((xi*(1.-tau)+tau*xy(i)*r_B)**2                        &
     &         +(yi*(1.-tau)+tau*(DAoverF+xy(i+1)*r_B))**2)             
          cc=h1/BoverF*8.-3. 
!     &       /BoverF*8.-3.                                             
!     &         -BoverF/2.                                              
          if(cc.ge.0.0) then 
           hh=hh*exp(-(cc*gdetector)**2) 
!           write(6,'(3i4,a,4f12.3)')jt,nS,nB,' sqrt(h), exp=',         
!     &      sqrt(h),exp(-(cc*gdetector)**2),h1*sc2aperture*sign(1.,xi) 
!          else                                                         
!           write(6,'(3i4,a,4f12.3)')jt,nS,nB,' sqrt(h), exp=',         
!     &      sqrt(h),1.0,h1*sc2aperture*sign(1.,xi)                     
          end if 
          sumi0=sumi0+hh 
         end do 
         if(xi.gt.0)then 
          xi=-xi 
          goto 2200 
         end if 
        end do 
       end if 
      end if 
                                                                        
                                                                        
   10 continue 
      jt=0 
      tau=1.0/(1.0-sqrt(geof(ichansp))*(1-HoverF)) 
      tau2=tau**2 
                                                                        
      goto(1001,1212,1222,1112,2221,2211,2111,2122) icase 
                                                                        
!     point source case=1, alignment                                    
 1001 continue 
!     dynamical decission according to tau(v)                           
!     normalization to effective efficiency at s=0 for all v.           
!     at that point is geof(ichansp)=1                                  
                                                                        
      jt=1 
      cosa(jt)=1.0 
      a_R(jt)=geof(ichansp) 
      jr=1. 
      RR=AoverF/2.0 
      if(RR*tau.lt.BoverF/2.) then 
       w_R=RR/N_B 
      do nR=2,N_B 
       RoverF=(nR-0.5)*w_R 
       jt=jt+1 
       jr=jr+2 
       h=1.0/(1.0+geof(ichansp)*RoverF**2*tau2) 
       cosa(jt)=sqrt(h) 
       a_R(jt)=geof(ichansp)*jr*h*cosa(jt) 
!         if(ichansp.eq.123)then                                        
!           write(6,'(a,10f10.5)')                                      
!     &  '1001  tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)=',               
!     &            tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)               
!         end if                                                        
      end do 
           ! RR.gt.BoverF/2.                                            
      else 
       w_R=BoverF/2./N_B 
      do nR=2,N_B 
       RoverF=(nR-0.5)*w_R 
       jt=jt+1 
       jr=jr+2 
       h=1.0/(1.0+geof(ichansp)*RoverF**2) 
       cosa(jt)=sqrt(h) 
       a_R(jt)=geof(ichansp)*jr*h*cosa(jt) 
!         if(ichansp.eq.123)then                                        
!           write(6,'(a,10f10.5)')                                      
!     &  '1001  tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)=',               
!     &            tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)               
!         end if                                                        
      end do 
      end if 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
      return 
                                                                        
!     parameter (r4=3.0, r11=4.4641, r20=6.2915, r33=8.2111)            
!     number 1,5,6,21,22 are of single weight                           
!     1-4 (r=3), 1-11 (2*sq3+1), 1-20 (2*sq7+1) 1-33 (2*sq13+1)         
!     point source case=1, misalignment                                 
                                                                        
!     else if(cyp_max.le.BoverF/2..and.cym_max.ge.-BoverF/2.)then       
!     Intersection is the full image of the absorber                    
 1212 continue 
!     number 1,5,6,21,22 are of single weight                           
      i=-1 
      do nB=1,N_B 
       i=i+2 
       jt=jt+1 
       xi=xy(i)*r_B 
       yi=DAoverF-DSoverF+xy(i+1)*r_B 
       h=1.0/(1.0+geof(ichansp)*(xi**2+yi**2)*tau**2) 
       cosa(jt)=sqrt(h) 
       a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nB) 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
      return 
                                                                        
!     Intersection is the full image of the aperture                    
 1222 continue 
!     number 1,5,6,21,22 are of single weight                           
      i=-1 
      do nB=1,N_B 
       i=i+2 
       xi=xy(i)*r_B 
       yi=-DSoverF+xy(i+1)*r_B 
       jt=jt+1 
       h0=xi**2+yi**2 
       h=1.0/(1.0+geof(ichansp)*h0) 
       cosa(jt)=sqrt(h) 
       a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nB) 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
      return 
                                                                        
!     else if(cym_min.lt.-BoverF/2.) then                               
!     Intersection; image of the absorber filled with cirles            
 1112 continue 
!     number 1,5,6,21,22 are of single weight                           
      hh=BoverF/2 
      i=-1 
      do nB=1,N_B 
       i=i+2 
       jt=jt+1 
       xi2=(xy(i)*r_B*tau)**2 
       yi=(DAoverF-DSoverF+xy(i+1)*r_B)*tau 
       h=1.0/(1.0+geof(ichansp)*(xi2+yi**2)) 
       a_R(jt)=geof(ichansp)*h*sqrt(h)*wt(nB) 
       cc=sqrt(xi2+(DSoverF+yi)**2)/BoverF*8.-3. 
       if(cc.gt.0.) then 
!       image out of aperture cirle (decreasing weight)                 
        a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2) 
       end if 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
      return 
                                                                        
!     ##################### extended source ##########################  
!     if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then                      
!     alignment                                                         
 2221 continue 
                                                                        
!     image covers aperture for all source points                       
!     integration over aperture (rings), source circles                 
      hh=0. 
      w_R=BoverF/2.0/N_B 
      jR=-1 
      do nR=1,N_B 
       RoverF=(nR-0.5)*w_R 
       jR=jR+2 
       i=-1 
       do nS=1,N_S 
        jt=jt+1 
        i=i+2 
        v2=(xy(i)*r_S)**2+(RoverF-xy(i+1)*r_S)**2 
        h=1./(1.+geof(ichansp)*v2) 
        cosa(jt)=sqrt(h) 
        a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nS)*jR 
!        if(ichansp.eq.1)then                                           
!          write(6,'(2i4,a,6f12.3)')nS,nR,' sqrt(h)=',                  
!     &        sqrt(h),wt(nS),float(jR)                                 
!        end if                                                         
       end do 
      end do 
      goto 2202 
                                                                        
 2211 continue 
!     integration over image, source ring/image circles                 
!     image inside aperture for all source points                       
      w_R=SoverF/2.0/N_B 
      jR=-1 
      do nS=1,N_B 
       RoverF=(nS-0.5)*w_R 
       jR=jR+2 
       i=-1 
       do nB=1,N_B 
        jt=jt+1 
        i=i+2 
        kx=xy(i)*r_B 
        ky=-RoverF+xy(i+1)*r_B 
        h=1.0/(1.0+geof(ichansp)*(kx**2+ky**2)*tau2) 
        cosa(jt)=sqrt(h) 
        a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nB)*jR 
       end do 
      end do 
      goto 2202 
                                                                        
 2111 continue 
!     source rings and image circles;                                   
!     aperture simulated by smooth edge                                 
      w_R=SoverF/2.0/N_B 
      jR=-1 
      do nS=1,N_B 
       RoverF=(nS-0.5)*w_R 
       jR=jR+2 
       i=-1 
       do nB=1,N_B 
        jt=jt+1 
        i=i+2 
        kx=xy(i)*r_B 
        ky=-RoverF+xy(i+1)*r_B 
        h=1.0/(1.0+geof(ichansp)*(kx**2+ky**2)*tau2) 
        cosa(jt)=sqrt(h) 
        a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nB)*jR 
        cc=sqrt((tau*xy(i)*r_B)**2+                                     &
     &          (RoverF*(1.-tau)+tau*xy(i+1)*r_B)**2)/BoverF*8.-3.      
        if(cc.gt.0.0) then 
         a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2) 
        end if 
       end do 
      end do 
      goto 2202 
                                                                        
!     Intersection; general case; image filled with circles             
!     finite aperture simulated by a smooth edge                        
 2122 continue 
      j=-1 
      do nS=1,N_S 
       j=j+2 
       xi=xy(j)*r_S 
       yi=xy(j+1)*r_S+DSoverF 
 2201  i=-1 
       do nB=1,N_B 
        jt=jt+1 
        i=i+2 
        k2=(xy(i)*r_B-xi)**2+(xy(i+1)*r_B+DAoverF-yi)**2 
        h=1./(1.+geof(ichansp)*k2*tau2) 
        cosa(jt)=sqrt(h) 
        a_R(jt)=geof(ichansp)*h*cosa(jt)*wt(nS) 
        h1=sqrt((xi*(1.-tau)+tau*xy(i)*r_B)**2+                         &
     &          (yi*(1.-tau)+tau*(DAoverF+xy(i+1)*r_B))**2)             
          cc=h1/BoverF*8.-3. 
        if(cc.ge.0.0) then 
         a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2) 
!         if((ichansp.eq.256.or.ichansp.eq.768).and.a_R(jt).gt.0.01)    
!     &     write(6,'(3i4,a,4f10.3)')jt,nS,nB,' sqrt(h), exp=',sqrt(h), 
!     &      exp(-(cc*gdetector)**2),h1*sc2aperture*sign(1.,xi),a_R(jt) 
!        else                                                           
!          if((ichansp.eq.256.or.ichansp.eq.768).and.a_R(jt).gt.0.01)   
!     &       write(6,'(3i4,a,4f10.3)')jt,nS,nB,' sqrt(h), exp=',       
!     &      sqrt(h),1.0,h1*sc2aperture*sign(1.,xi),a_R(jt)             
        end if 
       end do 
       if(xi.gt.0)then 
        xi=-xi 
        goto 2201 
       end if 
      end do 
 2202 do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine moss_selsubspect(text) 
      use glbconst, only: maxfr1,maxfr2,mc_scrd,mr_scrd,mi_scrd,maxscr, &
                          maxss,maxthss,maxsub,nrd,nwr
      use complt, only: n_int,n_subset
      implicit none  

      character(len=40),intent(in),dimension(3):: text
      character(len=4):: c_array 
      integer       i_array
      real          r_array 
      integer,parameter:: iiarr=mi_scrd-maxscr 
      common/scrd/ npanum(maxscr),i_array(iiarr),                       &
                   r_array(mr_scrd),c_array(mc_scrd)                    
                                                                        
      integer     istruct0,mstruct1,istruct1,istruct2,                  &
                  l1_get,l2_get,l3_get,l1_put,l2_put,l3_put             
      character(len=4) :: c1_prp,c2_prp,c3_prp
      character(len=64):: frthname
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                    l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                    c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                    frthname(2),istruct0(32)                            
                                                                        
                                                                        
      character(len=40) :: htext,text1,text2
      character(len=132):: ch132,cp132,chcom
      character(len=1)  :: ch1
      logical   bs_and_a 
      real,dimension(32):: out
      integer   i,ik,ipos,iout,is,is_a,is_and_a,is_e,iset,j,j1,j2,      &
                j_int,jabsorber,jsource,ji,jj,jz,kk,lay,mlay,n_ssub,nn, &
                ia,ii,npanum

      mlay=istruct1(mstruct1) 
!     mlay : number of layers                                           
                                                                        
                                                                        
!     subspectra for the plot, calculating subspectrum(1024,12)         
       jz=1 
       do while(text(2)(jz:jz).eq.' ') 
        jz=jz+1 
       end do 
       j2=1 
       do while(text(2)(jz:jz).ne.' ') 
        text2(j2:j2)=text(2)(jz:jz) 
        if(jz.eq.40) goto 801 
        jz=jz+1 
        j2=j2+1 
       end do 
  801  continue 
       jz=1 
       do while(text(1)(jz:jz).eq.' ') 
        jz=jz+1 
       end do 
       j1=1 
       do while(text(1)(jz:jz).ne.' ') 
        text1(j1:j1)=text(1)(jz:jz) 
        if(jz.eq.40) goto 802 
        jz=jz+1 
        j1=j1+1 
       end do 
  802   continue 
                                                                        
      is=0 
      do lay=1,mlay 
       is_a=istruct2(lay-1)+1 
       is_e=istruct2(lay) 
       htext=text(2) 
       if(lay.eq.1) htext=text(1) 
       if(lay.eq.mlay.and.mstruct1.eq.3) htext=text(3) 
       if(is_e.ge.is_a) then 
                                                                        
        write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',           &
     &      htext(1:jz),' sites from ',is_a,' to ',is_e                 
        is=is+is_e-is_a+1 
       end if 
      end do 
!      if((index(text(1),'source').gt.0.and.istruct2(mlay).lt.3)        
      if(is.lt.3) then 
       write(nwr,'(a)') '**  there are no sub-spectra ** ' 
       return 
      end if 
      is_and_a=0 
      bs_and_a=.true. 
!      if(index(text(1),'source').gt.0.and.istruct2(1).eq.1) then       
      if(istruct2(1).eq.1) then 
!      no source sub-spectrum                                           
       bs_and_a=.false. 
       is_and_a=1 
      end if 
      if(istruct2(mlay)-istruct2(1).eq.1) then 
!      no absorber  sub-spectrum                                        
       bs_and_a=.false. 
       is_and_a=2 
      end if 
                                                                        
                                                                        
  809  if(bs_and_a) then 
        write(nwr,'(/,6a)') ' sub-spectrum_j of ',                      &
     &  text1(:j1),'(ji) and ',text2(:j2),'(ki).',                      &
     &    ' Number j (h-ide), sites: j1...jn k1...kn'                   
                                                                        
       else if(is_and_a.eq.1)then 
        write(nwr,'(/,3a)') ' sub-spectrum_j of the ',                  &
     &  text2(:j2),'  Number j (h-hide),  site: k1...kn'                
                                                                        
       else if(is_and_a.eq.2)then 
        write(nwr,'(/,3a)') ' sub-spectrum_j of the ',                  &
     &  text1(:j1),'  Number j (h-ide), site: j1...jn '                 
       end if 
                                                                        
       i=1 
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0) 
        i=i+1 
        if(i-1.eq.maxsub) goto 8091 
       end do 
 8091  ik=i-1 
                                                                        
       i=0 
  805  i=i+1 
        j_int=abs(n_int(i,0)) 
        kk=0 
        do jj=1,j_int 
         if(n_int(i,jj).gt.is_e) kk=kk+1 
        end do 
        if(kk.gt.0)then 
         do kk=i,ik 
          j_int=abs(n_int(kk+1,0)) 
          if(j_int.gt.0) then 
           do jj=0,j_int 
            n_int(kk,jj)=n_int(kk+1,jj) 
           end do 
          else 
           do jj=0,maxss 
            n_int(ik,jj)=0 
           end do 
          end if 
         end do 
         ik=ik-1 
         i=i-1 
        end if 
        if(i.lt.ik)goto 805 
                                                                        
  810  i=1 
       n_subset=0 
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0) 
        ch1=' ' 
        if(n_int(i,0).lt.0) ch1='h' 
        j_int=abs(n_int(i,0)) 
        kk=0 
        do jj=1,j_int 
         if(n_int(i,jj).gt.is_e) kk=kk+1 
        end do 
        if(kk.gt.0)then 
         n_int(i,0)= 0 
         j_int=0 
         i=i-1 
        end if 
        if(is_and_a.eq.0) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
     &    ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int)               
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
     &    ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int)               
        end if 
        if(is_and_a.eq.1) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
     &    ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=2,j_int)               
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
     &    ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=2,j_int)               
        end if 
        if(is_and_a.eq.2) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
     &    ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int-1)             
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
     &    ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int-1)             
        end if 
        if(ch1.eq.' ')  n_subset=i 
        i=i+1 
        if(i-1.eq.maxsub) goto 811 
       end do 
  811  n_ssub=i-1 
                                                                        
  820  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/input' 
        call help(chcom) 
        goto 809 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 810 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
                                                                        
        call panum(ch132,maxss,npanum,1) 
!        write(6,'(a)')' npanum(1-npanum(2))'                           
!        write(6,'(20i3)')(npanum(j),j=1,npanum(2)+2)                   
                                                                        
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a,i3)') ' maximal number of sub-spectra ',maxsub 
          goto 810 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
     &    ' at least the number of the sub-spectrum (or *)'             
          goto 820 
        end if 
        if(iout.eq.1) then 
!        hide a sub-spectrum                                            
         if(ch132(1:1).eq.'h') then 
          if(n_int(iset,0).lt.0) then 
           n_int(iset,0)= abs(n_int(iset,0)) 
           do j=maxsub,2,-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub) then 
            do ji=0,maxss 
             n_int(1,ji)=n_int(iset+1,ji) 
             n_int(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_int(iset,0)=-abs(n_int(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(iset,ji) 
             n_int(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
!        remove a sub-spectrum                                          
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_int(maxsub,ji)=0 
          end do 
!          write(6,'(8i3)')n_int                                        
         end if 
        end if 
!       write(6,'(a,10i4)') ' 1 out=',(int(out(j)),j=1,iout)            
                                                                        
        if(iout.eq.2.and.bs_and_a) then 
         write(nwr,'(a)')                                               &
     &    '**** at least one source and absorber sub-spectrum'          
          goto 820 
        end if 
                                                                        
        if(iout.ge.2) then 
         nn=out(2) 
         if(nn.gt.istruct2(1).and.bs_and_a) then 
          write(nwr,'(a,i2)')                                           &
     &    '**** at least one source sub-spectrum  <=',istruct2(1)       
          goto 820 
         end if 
!        write(6,'(a,10i4)') ' 2 out=',(int(out(j)),j=1,iout)           
         n_int(iset,0)=0 
         jsource=0 
         jabsorber=0 
         iout=npanum(2)+1 
!         do j=2,iout                                                   
!          nn=out(j)                                                    
          do j=2,iout 
          nn=npanum(1+j) 
          if(nn.gt.is_e) then 
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a sub-spectrum' 
          else 
           if(nn.le.istruct2(1)) jsource=jsource+1 
           if(nn.gt.istruct2(1)) jabsorber=jabsorber+1 
           if(is_and_a.eq.0) then 
            n_int(iset,0)=j-1 
            n_int(iset,j-1)=nn 
           end if 
           if(is_and_a.eq.1) then 
            n_int(iset,0)=j 
            n_int(iset,1)=1 
            n_int(iset,j)=nn 
            jsource=1 
           end if 
           if(is_and_a.eq.2) then 
            n_int(iset,0)=j 
            n_int(iset,j-1)=nn 
            n_int(iset,j)=istruct2(mlay) 
            jabsorber=1 
           end if 
          end if 
         end do 
         if(jsource.eq.0.and.bs_and_a) then 
           write(nwr,'(a)')                                             &
     &     '****  at least one sub-spectrum of the source '             
           goto 820 
          end if 
          if(jabsorber.eq.0.and.bs_and_a) then 
           write(nwr,'(a)')                                             &
     &     '****  at least one sub-spectrum of the absorber'            
           goto 820 
          end if 
         end if 
!        write(6,'(a,10i4)')'n_int(1,0)=',(n_int(1,ji),ji=0,5)          
         jj=n_ssub 
         do i=1,maxsub-1 
          if(n_int(i,1).lt.0.and.n_int(i+1,1).gt.0) then 
           jj=jj+1 
           if(jj.le.maxsub) then 
            do ji=0,maxss 
             n_int(jj,ji)=n_int(i,ji) 
            end do 
           else 
            do ji=0,maxss 
             n_int(i,ji)=0 
            end do 
           end if 
          end if 
         end do 
         do i=1,maxsub 
          if(n_int(i,1).eq.0) then 
           do j=i,maxsub-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
         end do 
         goto 810 
               ! * out                                                  
       end if 
                                                                        
      return 
      END                                           
                                                                        
!------------------------------------------------------------------     
                                                                        
      subroutine moss_selsubtract(text,isub) 
      use glbconst, only: maxfr1,maxfr2,mi_scrd,mc_scrd,mr_scrd,maxscr,&
                          maxss,maxthss,maxsub,nrd,nwr
      use complt, only:   n_sub
      use comthe, only:   array_fr
      implicit none
                                                                        
      character(len=40),intent(in),dimension(3):: text
      integer       isub 
      real          r_array 
      integer,parameter :: maxsouab=5
                                                                        
      integer     mstruct1,istruct1,istruct2,idex,ifrth,iaddr,          &
                  l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,            &
                  nstorTH,nstorTH1,nstorTHyy,nstorSI,                   &
                  idum1,idum2,idum3,idum4,nLG,nRS,nsampling             
      character(len=4) :: c1_prp,c2_prp,c3_prp
      character(len=64):: frthname
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                    l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                    c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                    frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,     &
                    iaddr(4),idum1,idum2,nCC,ifrth(5),                  &
                    idum3,idum4,nLG,nRS,nTH,nsampling,idex(10)          
                                                                        
      real,dimension(32):: out 
                                                                        
      character(len=40) :: htext,texta
      character(len=132):: ch132,cp132,chcom
      character(len=1)  :: ch1
                                                                        
      integer,parameter :: jSI=maxsub*(maxss+1)
      integer,dimension(maxss+3):: npanum
      integer,dimension(2*jSI):: i_int
      integer,dimension(maxsub,0:maxss):: n_source,n_absorber 
      equivalence (i_int(1),n_source), (i_int(jSI+1),n_absorber) 

      integer   i,ia,ii,is_a,is_e,iset,j,jab,ji,jj,jsou,jsource,        &
                lay,laye,mlay,n_ssub,nn,iout,ipos,lch,ncc,nth


                                                                        
      do i=1,jSI 
       i_int(i)=real(array_fr(nstorSI+i)) 
       i_int(i+jSI)=aimag(array_fr(nstorSI+i)) 
      end do 
      do i=1,maxsub 
       n_source(i,0)=0 
       n_absorber(i,0)=0 
      end do 
!     mlay : number of layers                                           
      mlay=istruct1(mstruct1) 
                                                                        
      laye=mlay 
      if(mstruct1.eq.3) laye=mlay-1 
      n_source(1,0)=0 
      if(istruct2(1).eq.1) goto 875 
       is_a=1 
       is_e=istruct2(1) 
       htext=text(1) 
       write(nwr,'(a,2(a,i2))')                                         &
     &   htext(:24),' sites from ',is_a,' to ',is_e                     
        cp132=htext 
        call nextchar(cp132,0,ipos,ch132,lch) 
        write(nwr,'(/,2a)')ch132(1:lch),                                &
     &       '_subsp_j      j1   j2 ...  [j=1]'                         
  860  i=1 
       do while(abs(n_source(i,0)).gt.0) 
        ch1=' ' 
        if(n_source(i,0).lt.0) ch1='h' 
        write(nwr,'(a,i1,a1,1x,32i3)') ' source_subsp_',                &
     &       i,ch1,(n_source(i,jj),jj=1,abs(n_source(i,0)))             
        i=i+1 
        if(i.gt.maxsouab) goto 861 
       end do 
  861  n_ssub=i-1 
                                                                        
  870  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/subtract/source' 
         call help(chcom) 
         goto 860 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 860 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
        call panum(ch132,maxss,npanum,1) 
                                                                        
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a)') ' maximal number of sub-spectra reached' 
          goto 860 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
     &    ' at least the number of the sub-spectrum (or *)'             
          goto 870 
        end if 
        if(iout.eq.1) then 
         if(ch132(1:1).eq.'h') then 
          if(n_source(iset,0).lt.0) then 
           n_source(iset,0)= abs(n_source(iset,0)) 
           do j=maxsouab,2,-1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub)then 
            do ji=0,maxss 
             n_source(1,ji)=n_source(iset+1,ji) 
             n_source(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_source(iset,0)=-abs(n_source(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(iset,ji) 
             n_source(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_source(maxsub,ji)=0 
          end do 
         end if 
        end if 
                                                                        
        if(iout.ge.2) then 
        n_source(iset,0)=0 
        jsource=0 
        iout=npanum(2)+1 
                                                                        
        do j=2,iout 
!        nn=out(j)                                                      
         nn=npanum(1+j) 
         if(nn.gt.istruct2(1)) then 
         write(nwr,'(a,i2,a)')                                          &
     &    '**** ',nn,' is not a source sub-spectrum  '                  
         else 
          jsource=jsource+1 
          n_source(iset,0)=j-1 
          n_source(iset,j-1)=nn 
         end if 
        end do 
         if(jsource.eq.0) then 
         write(nwr,'(a)')                                               &
     &    '****  no source sub-spectrum  '                              
         goto 870 
         end if 
        end if 
                                                                        
        jj=n_ssub 
        do i=1,maxsouab-1 
         if(n_source(i,1).lt.0.and.n_source(i+1,1).gt.0) then 
          jj=jj+1 
          if(jj.le.maxsouab) then 
           do ji=0,maxss 
            n_source(jj,ji)=n_source(i,ji) 
           end do 
          else 
           do ji=0,maxss 
            n_source(i,ji)=0 
           end do 
          end if 
         end if 
        end do 
        do i=1,maxsouab 
         if(n_source(i,1).eq.0) then 
          do j=i,maxsouab-1 
           do ji=0,maxss 
            n_source(j,ji)=n_source(j+1,ji) 
           end do 
          end do 
         end if 
        end do 
        goto 860 
               ! * out                                                  
       end if 
                                                                        
                                                                        
  875 do lay=2,mlay 
       is_a=istruct2(lay-1)+1 
       is_e=istruct2(lay) 
       htext=text(2) 
       if(lay.eq.mlay.and.mstruct1.eq.3) htext=text(3) 
       if(is_a.le.is_e)                                                 &
     &  write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',           &
     &             htext(1:24),' sites from ',is_a,' to ',is_e          
      end do 
                                                                        
  879 cp132=htext 
      call nextchar(cp132,0,ipos,ch132,lch) 
      texta=ch132 
      write(nwr,'(/,2a)')ch132(1:lch),                                  &
     &       '_subsp_j      j1   j2 ...  [j=1]'                         
  880 i=1 
      do while(abs(n_absorber(i,0)).gt.0) 
       ch1=' ' 
       if(n_absorber(i,0).lt.0) ch1='h' 
       write(nwr,'(2a,i1,a1,1x,32i3)') texta(:lch),'_subsp_',           &
     &     i,ch1,(n_absorber(i,jj),jj=1,abs(n_absorber(i,0)))           
       i=i+1 
       if(i.gt.maxsouab) goto 881 
      end do 
  881 n_ssub=i-1 
                                                                        
  890  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/subtract/absorber' 
         call help(chcom) 
         goto 879 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 880 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
        call panum(ch132,maxss,npanum,1) 
                                                                        
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a)') ' maximal number of sub-spectra reached' 
          goto 880 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
     &    ' at least the number of the sub-spectrum (or *)'             
          goto 890 
        end if 
        if(iout.eq.1) then 
         if(ch132(1:1).eq.'h') then 
          if(n_absorber(iset,0).lt.0) then 
           n_absorber(iset,0)= abs(n_absorber(iset,0)) 
           do j=maxsouab,2,-1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub)then 
            do ji=0,maxss 
             n_absorber(1,ji)=n_absorber(iset+1,ji) 
             n_absorber(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_absorber(iset,0)=-abs(n_absorber(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(iset,ji) 
             n_absorber(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_absorber(maxsub,ji)=0 
          end do 
         end if 
        end if 
                                                                        
        if(iout.ge.2) then 
        n_absorber(iset,0)=0 
        iout=npanum(2)+1 
        do j=2,iout 
!        nn=out(j)                                                      
         nn=npanum(1+j) 
        if(nn.le.istruct2(1).or.nn.gt.istruct2(laye)) then 
         write(nwr,'(a,i2,a)')                                          &
     &    '**** ',nn,' is not an absorber sub-spectrum  '               
         else 
          n_absorber(iset,0)=j-1 
          n_absorber(iset,j-1)=nn 
         end if 
        end do 
        end if 
                                                                        
        jj=n_ssub 
        do i=1,maxsouab-1 
         if(n_absorber(i,1).lt.0.and.n_absorber(i+1,1).gt.0)then             
          jj=jj+1 
          if(jj.le.maxsouab) then 
           do ji=0,maxss 
            n_absorber(jj,ji)=n_absorber(i,ji) 
           end do 
          else 
           do ji=0,maxss 
            n_absorber(i,ji)=0 
           end do 
          end if 
         end if 
        end do 
        do i=1,maxsouab 
         if(n_absorber(i,1).eq.0) then 
          do j=i,maxsouab-1 
           do ji=0,maxss 
            n_absorber(j,ji)=n_absorber(j+1,ji) 
           end do 
          end do 
         end if 
        end do 
        goto 880 
               ! * out                                                  
       end if 
                                                                        
!      source sub-spectra (and all absorber sub-spectra)                
       isub=1 
       if(n_source(1,0).gt.0) then 
        isub=2 
        n_sub(1,0)=n_source(1,0)+istruct2(laye)-istruct2(1) 
        do j=1,n_source(1,0) 
         n_sub(1,j)=n_source(1,j) 
        end do 
        do j=1,n_sub(1,0)-n_source(1,0) 
         n_sub(1,j+n_source(1,0))=istruct2(1)+j 
        end do 
                ! source sub-spectra                                    
       end if 
                                                                        
!      absorber sub-spectra (and remaining source sub-spectra)          
                                                                        
       jsou=0 
       do j=1,istruct2(1) 
        jj=0 
        do i=1,abs(n_source(1,0)) 
         if(abs(n_source(1,i)).eq.j) jj=1 
        end do 
        if(jj.eq.0) then 
         jsou=jsou+1 
         n_sub(0,jsou)=j 
        end if 
       end do 
                                                                        
        do j=1,jsou 
         n_sub(isub,j)=n_sub(0,j) 
        end do 
                                                                        
        jj=jsou 
        do j=1,n_absorber(1,0) 
          jj=jj+1 
          n_sub(isub,jj)=n_absorber(1,j) 
        end do 
        n_sub(isub,0)=jj 
                                                                        
!    reaining sub-spectrum stored in n_sub(0,j)                         
                                                                        
       jab=0 
       do j=istruct2(1)+1,istruct2(laye) 
        jj=0 
        do i=1,n_sub(isub,0) 
         if(n_sub(isub,i).eq.j) jj=1 
        end do 
        if(jj.eq.0) then 
         jab=jab+1 
         n_sub(0,jsou+jab)=j 
        end if 
       end do 
       n_sub(0,0)=jsou+jab 
                                                                        
      do i=1,jSI 
       array_fr(nstorSI+i)=cmplx(i_int(i),i_int(i+jSI)) 
      end do 
                                                                        
!       do i=1,isub                                                     
!       write(nwr,'(a,i1,2x,32i3)')                                     
!     &    ' sub-spectrum_',i,(n_sub(i,jj),jj=1,abs(n_sub(i,0)))        
!       end do                                                          
       write(nwr,'(a,1x,2x,32i3)')                                      &
     &    ' residual spectrum sites',(n_sub(0,jj),jj=1,abs(n_sub(0,0))) 
                                                                        
       print *,' ' 
       print *,'                         **** CALCULATING ****' 
!       print *,' '                                                     
       return 
      END                                           
                                                                        
                                                                        
     subroutine moss_subspect(cmch,mi,info) 
     use glbconst, only: maxn,maxthss,maxscrt,maxsub,icstrf,ivstrf
     use complt, only: n_subset,n_int
     use comthe, only: thfk
     implicit none 
     character(len=4),intent(in):: cmch 
     integer,intent(in) :: mi
     integer,intent(out):: info


     integer nchansp,i,ip,l,ll,j,k1                                 
     real    dum,channels,avsp,f_factor,base,dumcsp,dumcvs,dumscrt,    &
             datx,errx,sym,subspectrum                         
                                                                       
     common/acstrf/ dum(5),                                            &
                    channels,dumcsp(icstrf-6)                          
     common/avstrf/ avsp,f_factor,base,dumcvs(ivstrf-3) 
                                                                       
     integer,parameter:: idumscrt=maxscrt-maxn*maxsub-3*maxn 
     common/scrt/datx(maxn),errx(maxn),sym(maxn),                      &
                 subspectrum(maxn,maxsub),dumscrt(idumscrt)            
     real          velocity,geof,dfdgeo,p0 
     common/adrive/velocity(maxn),geof(maxn),dfdgeo(maxn) 
                                                                       
     real,dimension(maxthss):: plold 
                                                                        
      nchansp=channels 
                                                                        
      do i=1,maxn 
       dumscrt(i)=thfk(i) 
      end do 
                                                                        
       call calpl('test') 
                                                                        
       do  i=1,mi 
        plold(i)=0.0 
                                           ! - take out and write on plo
        call replace_wi(-i,plold(i),info) 
       end do 
!       write(6,'(i3,a,9f10.3)')mi,' subsp-plold(1..)=',(plold(i),i=1,mi
       nchansp=channels 
                                                                        
       do  l=1,n_subset 
        p0=0.0 
        do j=1,mi 
                                             ! + write 0 to wi values   
         call replace_wi(j,p0,info) 
        end do 
                                                                        
!       write(6,'(a,i4,a,30i3)')' l_subsp=',l,                          
!     &         ' n_int(l,ll)=',(n_int(l,ll),ll=0,n_int(l,0))           
        do ll=1,n_int(l,0) 
         ip=n_int(l,ll) 
                                             ! + write plold(ip) to wi v
         call replace_wi(ip,plold(ip),info) 
        end do 
                                                                        
        k1=3 
        call sel_the2exp(cmch,k1,info) 
        do  i=1,nchansp 
         subspectrum(i,l)=thfk(i) 
        end do 
!        write(6,'(a,i4)') '  sub-spectrum i=',l                        
!        write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)                   
       end do 
                                                                        
       do  i=1,mi 
                                          ! + write plold(i) to wi value
        call replace_wi(i,plold(i),info) 
       end do 
!       call moss_the2exp(k1,info)                                      
                                                                        
      do i=1,maxn 
       thfk(i)=dumscrt(i) 
      end do 
      return 
      END                                           
                                                                        
      subroutine moss_subtract(cmch,mi,isub,info) 
      use glbconst, only: maxn,maxscrt,maxthss,maxsub,icstrf,ivstrf
      use comdat, only: ichanks,mfpt
      use complt, only: n_sub
      use comthe, only: real_fr,thfk
      implicit none 
                                                                        
      integer idumscrt,mi,nchansp,                                      &
     &        i,j,jj,isub,k,k1,info                                     
      real    dum,channels,avsp,f_factor,base,dumcsp,dumcvs,dumscrt,    &
     &        datx,errx,sym,subspectrum                           
                                                                        
      common/acstrf/ dum(5),                                            &
     &               channels,dumcsp(icstrf-6)                          
      common/avstrf/ avsp,f_factor,base,dumcvs(ivstrf-3) 
                                                                        
      parameter(idumscrt=maxscrt-maxn*maxsub-3*maxn) 
      common/scrt/datx(maxn),errx(maxn),sym(maxn),                      &
     &            subspectrum(maxn,maxsub),dumscrt(idumscrt)            
      real velocity,geof,dfdgeo,p0 
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn) 
                                                                        
     character(len=4):: cmch 
     real,dimension(maxthss):: plold 
                                                                        
      nchansp=channels 
                                                                        
      do i=1,maxn 
       dumscrt(i)=thfk(i) 
      end do 
                                                                        
!     write(6,'(a,i4)') ' ********** mi=',mi                            
                                                                        
       call calpl('test') 
       do  i=1,mi 
        plold(i)=0.0 
                                           ! - take out and write on plo
        call replace_wi(-i,plold(i),info) 
       end do 
!      subtract y - yy                                                  
                                                                        
!      absorber complete , source and detector window subtracted        
                                                                        
       nchansp=channels 
                                                                        
       p0=0.0 
       do j=1,isub 
        do i=1,mi 
                                     ! + write 0 to wi values           
         call replace_wi(i,p0,info) 
        end do 
                                                                        
        do i=1,n_sub(j,0) 
         jj=abs(n_sub(j,i)) 
                                             ! + write plold(jj) to wi v
         call replace_wi(jj,plold(jj),info) 
        end do 
                                                                        
        k1=3 
        call sel_the2exp(cmch,k1,info) 
                                                                        
!      write(6,'(a)') ' ------1----back in subtract----------------'    
                                                                        
        do k=2,ichanks(0),2 
         do i=ichanks(k-1),ichanks(k) 
          real_fr(mfpt+i)=real_fr(mfpt+i)-(thfk(i)-base*geof(i)) 
         end do 
        end do 
               ! isub                                                   
       end do 
                                                                        
!      calculation of the theory of the stripped spectrum               
       p0=0.0 
       do i=1,mi 
                                    ! + write 0.0 to wi values          
        call replace_wi(i,p0,info) 
       end do 
                                                                        
       do i=1,n_sub(0,0) 
        jj=n_sub(0,i) 
                                            ! + write plold(jj) to wi va
        call replace_wi(jj,plold(jj),info) 
       end do 
                                                                        
       k1=3 
         ! values are not reset by calpl, written on theory-array       
       call sel_the2exp(cmch,k1,info) 
                                                                        
!      write(6,'(a)') ' ------2----back in subtract----------------'    
!      restore parameters                                               
       call calpl('test') 
                                                                        
      do i=1,maxn 
       thfk(i)=dumscrt(i) 
      end do 
                                                                        
      return 
      END                                           
                                                                        
!      subroutine forstruct                                             
!      implicit none                                                    
!      use glbconst                                             
!      integer      istruct,idum                                        
!      parameter   (istruct=2+4*maxfr1+4+4*maxfr2+3*maxthss+32+8+8+16)  
!      common/struct/idum(istruct)                                      
!      return                                                           
!      end                                                              
                                                                        
     subroutine mosstrans_mcarlo(nu_channel) 
     use glbconst, only: iseed,ivstrf
     use comthe, only: thfk
     implicit none 
                                                                       
     real          avsp,f_factor,base,bg_fraction,dumvsp                   
     common/avstrf/avsp,f_factor,base,bg_fraction,dumvsp(ivstrf-4) 
                                                                       
     integer i,nu_channel,ledit 
     real    win_fraction,countrate,deadtime,                          &
             sweepfrequency,ameasuretime,printtime,dwelltime,          &
             start,finish,bg_fract,fres                                                
     character(len=132):: chcrd,chcom 
     real,dimension(7):: value
     character(len=40),dimension(7):: name                                                                        
        bg_fract=bg_fraction+(1.-f_factor)*(1.-bg_fraction) 
        fres=f_factor*(1.-bg_fraction) 
        do i=1,nu_channel 
         thfk(i)=1.+(thfk(i)/base-1.)/fres 
        end do 
                                                                        
!       25:32 information about the helpfile (th110105)                 
!             if 25:32 is empty chcom is taken by subroutine conread    
!             as defined below                                          
!       33:37 format (effi specific) of the number                      
!                  1234567890123456789012345678901234567                
        name(1)='win_fraction                    f04.2)' 
        name(2)='countrate(/sec)                 e08.1)' 
        name(3)='deadtime (ms)                   e06.1)' 
        name(4)='sweepfrequency(Hz)              f05.1)' 
        name(5)='measure_time (sec)              i03)' 
        name(6)='printtime (sec)                 i03)' 
        name(7)='iseed                           i09)' 
                                                                        
                             ! fraction of conuts in the window         
        win_fraction=0.8 
                             ! in the window                            
        countrate=1.e5 
        deadtime=1.e-5 
        sweepfrequency=10. 
        ameasuretime=30 
        printtime=10 
        iseed=-222 
                                                                        
        chcrd='1-7' 
        chcom='<Mossbauer_spectrum>/trans/simulation/montecarlo' 
                                                                        
                                 ! fraction of conuts in the window     
        value(1)=win_fraction  ! in the window
        value(2)=countrate 
        value(3)=deadtime 
        value(4)=sweepfrequency 
        value(5)=ameasuretime 
        value(6)=printtime 
        value(7)=iseed 
                                                                        
        ledit=0 
        call conread(chcrd,value,name,7,chcom,ledit) 
                                                                        
        win_fraction=  value(1) 
        countrate=     value(2) 
        deadtime=      value(3) 
        sweepfrequency=value(4) 
        ameasuretime=  value(5) 
        printtime=     value(6) 
        iseed=         value(7) 
                                                                        
        dwelltime=1./sweepfrequency/nu_channel 
        call cpu_time(start) 
        call mosstranscounts(base,nu_channel,win_fraction,bg_fract,     &
     &      countrate,deadtime,dwelltime,ameasuretime,printtime,iseed)  
                                                                        
        call cpu_time(finish) 
        print '(" runtime = ",f15.3," seconds.")',finish-start 
                                                                        
        return 
      END                                           
                                                                        
                                                                        
